 function [out] = casadi_vec2struct(s,vec)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%@Course      : Master Thesis Spring 2018
%@Task        : Function that converts a vector to a struct
%@input       : vector (vec), struct (s) 
%            
%@output      : struct (out)

%@author      : Joris Gillis, Rien Quirynen, Joel Andersson,
%               Sebastien Gros and Moritz Diehl
%@modified    : Adriaen Verheyleweghen
%@organization: Faculty of Engineering, University of Frieburg, Germany
%@requires    : MATLAB R2016a  (not tested in other releases)     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  import casadi.*
  assert(isvector(vec))
  try
      vec.sparsity();
  catch
      vec = DM(vec);
  end
  flat = {};
  if isstruct(s)
    out = struct;
    sizes = 0;
    for f=fieldnames(s)'
      dim = size(casadi_struct2vec(s.(f{1})));
      sizes = [sizes,sizes(end)+dim(1)];
    end
    comps = vertsplit(vec,sizes);
    i = 1;
    for f=fieldnames(s)'
      out.(f{1}) = casadi_vec2struct(s.(f{1}),comps{i});
      i = i+1;
    end
  elseif iscell(s)
    out = cell(size(s));
    sizes = 0;
    for i=1:length(s)
      n = size(casadi_struct2vec_new(s{i}),1);
      sizes = [sizes,sizes(end)+n];
    end
    comps = vertsplit(vec,sizes);
    for i=1:length(s)
      out{i} = casadi_vec2struct(s{i},comps{i});
    end
      else
    out = reshape(vec,size(s));
  end
end