function cvar_out = cvar_func(lambda,k,alpha )
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%@Course      : Master Thesis Spring 2018
%@Task        : Calculating Conditional Value-at-Risk at time t for lambda,
%               k and alpha
%@input       : scale parameter(lambda) and shape parameter (k) in the 
%               Weibull distribution, confidence level for risk (alpha)
%@output      : value for Conditional Value-at-Risk 

%@author      : Julie Berge Ims
%@organization: Department of Chemical Engineering, NTNU, Norway
%@created     : February 2018
%@requires    : MATLAB R2016a (not tested in other releases)                                                          
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Weibull quantile function 
    quantile = @(lambda,k,alpha) (lambda*(-log(1-alpha))^(1/k));

    % VaR-variable declaration
    var_out = 0;

    % Step-size in integration
    dy = 0.0001;

    % Integrating VaR from 0.0 to alpha
    for i = 0.00:dy:alpha
        var_out = var_out + (quantile(lambda,k, i))*dy;
    end

    % Dividing the integral by alpha
    cvar_out = var_out/alpha;

end
